/*---------------------------------------------------------------------------
				map_case - offline map reader for Age of Adventure
			  Copyright (c) 2000-2001 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation: either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
	for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5

	Original programming: 	Alan Lenton
	Additional programming:	Stanley Lenton

	Home website:				www.ibgames.net
---------------------------------------------------------------------------*/

#ifndef AGEMAP_H
#define AGEMAP_H

#include <map>

using namespace std;

class Location;

typedef map< int, Location *,less<int> > LocList;

class AgeMap
{
private:
	static Graphics::TBitmap	*map_gfx;

	char		title[80];		// the formal title of the map
	LocList	loc_list;		// list of locations

	int	CheckDiagonalLink(int GridCol,int GridRow,int tile_size);
	int	CheckLeftRightLink(int GridCol,int GridRow,int tile_size);
	int	CheckUpDownLink(int GridCol,int GridRow,int tile_size);

	bool	CheckExit(int GridCol,int GridRow, int dir);
	bool	IsPossibleLoc(int grid_col,int grid_row);

	void	Clear();

public:
	AgeMap(FILE *file);
	~AgeMap();

	static void LoadMapGfx();
	static void	DeleteMapGfx()		{ delete map_gfx; return; }

	void	DrawCell(int GridCol,int GridRow,TRect &rect,int tile_size);
	void	Name2Status(int cur_col,int cur_row);
	void	Save(FILE *file);
	void	ShowNotes(int cur_col,int cur_row,int X,int Y);
};

#endif
