/*---------------------------------------------------------------------------
				map_case - offline map reader for Age of Adventure
			  Copyright (c) 2000-2001 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation: either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
	for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5

	Original programming: 	Alan Lenton
	Additional programming:	Stanley Lenton

	Home website:				www.ibgames.net
---------------------------------------------------------------------------*/

#ifndef LOCATION_H
#define LOCATION_H

#include <cstdio>

using namespace std;

class Location
{
public:
	enum	{ MAX_NAME = 40 };

protected:
	int	column;	  				// x position on the map
	int	row;		  				// y position on the map
	int	exits;	  				// Normal exits from this location
	char	name[MAX_NAME];		// The location's name

	char	*notes;					// Player's own notes, if any

public:
	Location(char *txt);
	~Location();

	int	Column()					{ return(column);	}
	int	Row()						{ return(row);		}
	int	Exits()					{ return(exits); 	}
	const char 	*Notes()			{ return(notes); 	}
	const char  *Name()			{ return(name);	}

	bool 	IsOK()					{ return(column != -1); }

	void	Save(FILE *file);
	void	ShowNotes(int X,int Y);
	void	UpdateNotes();
};

#endif

