/*---------------------------------------------------------------------------
				map_case - offline map reader for Age of Adventure
			  Copyright (c) 2000-2001 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation: either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
	for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5

	Original programming: 	Alan Lenton
	Additional programming:	Stanley Lenton

	Home website:				www.ibgames.net
---------------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "main.h"

#include <cstdio>
#include <cstring>

using namespace std;

#include "age_map.h"
#include "notes.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------

__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
	is_clean = true;
	strcpy(version,"Version 1.02");
}

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	if(!is_clean)
	{
		switch(MessageDlg("You have unsaved notes -\nsave map to disk?",mtConfirmation,TMsgDlgButtons() << mbYes << mbNo << mbCancel,0))
		{
			case mrYes:	SaveItemClick(this);	Action = caFree;	break;
			case mrNo:	Action = caFree;								break;
			case mrCancel:	Action = caNone;							return;
		}
	}

	delete age_map;
	AgeMap::DeleteMapGfx();

	return;
}

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	char	buffer[160];

	age_map = 0;
	AgeMap::LoadMapGfx();
	file_name[0] = '\0';
	sprintf(buffer,"Age of Adventure Map Case - %s",version);
	Caption = buffer;
	return;
}



void __fastcall TMainForm::ExitItemClick(TObject *Sender)
{
	Close();
}

void __fastcall TMainForm::GridDrawCell(TObject *Sender, int ACol,
		int ARow, TRect &Rect, TGridDrawState State)
{
	if(age_map != 0)
		age_map->DrawCell(ACol,ARow,Rect,Grid->DefaultColWidth);
	return;
}

void __fastcall TMainForm::GridMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
	int	cur_col,cur_row;

	Grid->MouseToCell(X,Y,cur_col,cur_row);
	if(age_map != 0)
		age_map->ShowNotes(cur_col,cur_row,X,Y);
	return;
}

void __fastcall TMainForm::GridMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
	int	cur_col,cur_row;

	Grid->MouseToCell(X,Y,cur_col,cur_row);
	if(age_map != 0)
		age_map->Name2Status(cur_col,cur_row);

	return;
}

void __fastcall TMainForm::GridTopLeftChanged(TObject *Sender)
{
  StaticText->Visible = false;
  MainForm->Status->Panels->Items[1]->Text = "";
}

void __fastcall TMainForm::StaticTextClick(TObject *Sender)
{
  StaticText->Visible = false;
  MainForm->Status->Panels->Items[1]->Text = "";
}

void __fastcall TMainForm::OpenItemClick(TObject *Sender)
{
  StaticText->Visible = false;
	FILE	*file;

	if(OpenDialog->Execute())
	{
		strcpy(file_name,OpenDialog->FileName.c_str());
		if((file = fopen(file_name,"r")) == 0)
			MessageDlg("Can't open file!",mtInformation,TMsgDlgButtons() << mbOK,0);
		else
		{
			age_map = new AgeMap(file);
			SaveItem->Enabled = true;
			is_clean = true;
			fclose(file);
		}
	}
	Grid->Refresh();

	return;
}

void __fastcall TMainForm::SaveItemClick(TObject *Sender)
{
	FILE	*file;

	if((file = fopen(file_name,"w")) == 0)
		MessageDlg("Can't open file!",mtInformation,TMsgDlgButtons() << mbOK,0);
	else
	{
		age_map->Save(file);
		fclose(file);
		MessageDlg("Map Saved",mtInformation,TMsgDlgButtons() << mbOK,0);
		is_clean = true;
	}

	return;
}

void __fastcall TMainForm::StatusClick(TObject *Sender)
{
  StaticText->Visible = false;
  if(NotesForm->NotesMemo->Lines->Count != 0)
  {
	 NotesForm->Visible = true;
	 NotesForm->BringToFront();
	 MainForm->Status->Panels->Items[1]->Text = "";
  }
}


