/*---------------------------------------------------------------------------
				map_case - offline map reader for Age of Adventure
			  Copyright (c) 2000-2001 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation: either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
	for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5

	Original programming: 	Alan Lenton
	Additional programming:	Stanley Lenton

	Home website:				www.ibgames.net
---------------------------------------------------------------------------*/

#ifndef MAIN_H
#define MAIN_H

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <printers.hpp>
//---------------------------------------------------------------------------

class AgeMap;

class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TDrawGrid *Grid;
	TStatusBar *Status;
	TMainMenu *MainMenu;
	TMenuItem *File1;
	TMenuItem *OpenItem;
	TMenuItem *ExitItem;
	TOpenDialog *OpenDialog;
	TMenuItem *SaveItem;
  TStaticText *StaticText;
  TMenuItem *N2;
	void __fastcall OpenItemClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall GridDrawCell(TObject *Sender, int ACol, int ARow,
			 TRect &Rect, TGridDrawState State);
	void __fastcall ExitItemClick(TObject *Sender);
	void __fastcall GridMouseMove(TObject *Sender, TShiftState Shift, int X,
			 int Y);
	void __fastcall GridMouseDown(TObject *Sender, TMouseButton Button,
			 TShiftState Shift, int X, int Y);
	void __fastcall SaveItemClick(TObject *Sender);
  void __fastcall StatusClick(TObject *Sender);
  void __fastcall GridTopLeftChanged(TObject *Sender);
  void __fastcall StaticTextClick(TObject *Sender);

private:
	AgeMap	*age_map;
	char		file_name[256];
	char		version[64];
	bool		is_clean;

public:
	__fastcall TMainForm(TComponent* Owner);

	bool	IsClean()			{ return(is_clean); }
	void	IsClean(bool val)	{ is_clean = val; return; }
};

//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------

#endif

